#ifndef __LIBRARY_H
#define __LIBRARY_H

// user definition ...

extern "C" {
    CONCEPT_DLL_API ON_CREATE_CONTEXT MANAGEMENT_PARAMETERS;
    CONCEPT_DLL_API ON_DESTROY_CONTEXT MANAGEMENT_PARAMETERS;

    CONCEPT_FUNCTION(PPInit)
    CONCEPT_FUNCTION(PPDone)

    CONCEPT_FUNCTION(PPCompile)
    CONCEPT_FUNCTION(PPRelease)
    CONCEPT_FUNCTION(PPKernel)
    CONCEPT_FUNCTION(PPReleaseKernel)
    CONCEPT_FUNCTION(PPGo)
    CONCEPT_FUNCTION(PPFinish)

    CONCEPT_FUNCTION(PPConcept)
    CONCEPT_FUNCTION(PPConceptGo)

    CONCEPT_FUNCTION(get_global_id)
    CONCEPT_FUNCTION(get_local_id)
    CONCEPT_FUNCTION(get_global_size)
    CONCEPT_FUNCTION(get_local_size)
    CONCEPT_FUNCTION(get_work_dim)
    CONCEPT_FUNCTION(get_num_groups)
    CONCEPT_FUNCTION(get_group_id)
    CONCEPT_FUNCTION(get_global_offset)

    CONCEPT_FUNCTION(barrier)
    CONCEPT_FUNCTION(PPNative)
}

#endif // __LIBRARY_H
