#ifndef __LIBRARY_H
#define __LIBRARY_H

#include "stdlibrary.h"

extern "C" {
    CONCEPT_DLL_API ON_CREATE_CONTEXT MANAGEMENT_PARAMETERS;
    CONCEPT_DLL_API ON_DESTROY_CONTEXT MANAGEMENT_PARAMETERS;

    CONCEPT_FUNCTION(DTMFGeneratorInit)
    CONCEPT_FUNCTION(DTMFGeneratorDone)
    CONCEPT_FUNCTION(DTMFGeneratorGenerate)
    CONCEPT_FUNCTION(DTMFGeneratorTransmit)
    CONCEPT_FUNCTION(DTMFGeneratorReady)
    CONCEPT_FUNCTION(DTMFGeneratorReset)

    CONCEPT_FUNCTION(DTMFDetectorInit)
    CONCEPT_FUNCTION(DTMFDetectorDone)
    CONCEPT_FUNCTION(DTMFDetectorReset)
    CONCEPT_FUNCTION(DTMFDetectorDetect)
    CONCEPT_FUNCTION(DTMFDetectorButtons)
}


#endif // __LIBRARY_H
