#ifndef __LIBRARY_H
#define __LIBRARY_H

#include "stdlibrary.h"

extern "C" {
	    CONCEPT_DLL_API ON_CREATE_CONTEXT MANAGEMENT_PARAMETERS;
	    CONCEPT_DLL_API ON_DESTROY_CONTEXT MANAGEMENT_PARAMETERS;

        CONCEPT_FUNCTION(BTSocketCreate)
        CONCEPT_FUNCTION(BTSocketClose)
        CONCEPT_FUNCTION(BTSocketListen)
        CONCEPT_FUNCTION(BTSocketAccept)
        CONCEPT_FUNCTION(BTSocketConnect)
        CONCEPT_FUNCTION(BTSocketInfo)

        CONCEPT_FUNCTION(BTDiscover)
        CONCEPT_FUNCTION(BTRegister)
        CONCEPT_FUNCTION(BTUnregister)
}


#endif // __LIBRARY_H
