#ifndef __LIBRARY_H
#define __LIBRARY_H

#include "stdlibrary.h"

extern "C" {
	    CONCEPT_DLL_API ON_CREATE_CONTEXT MANAGEMENT_PARAMETERS;
	    CONCEPT_DLL_API ON_DESTROY_CONTEXT MANAGEMENT_PARAMETERS;

        CONCEPT_FUNCTION(RTP_Create)
        CONCEPT_FUNCTION(RTP_Destroy)
        CONCEPT_FUNCTION(RTP_Send)
        CONCEPT_FUNCTION(RTP_Build)
        CONCEPT_FUNCTION(RTP_Add_Send_Addr)
        CONCEPT_FUNCTION(RTP_Rem_Send_Addr)
        CONCEPT_FUNCTION(Set_Extension_Profile)
        CONCEPT_FUNCTION(Add_Extension)
        CONCEPT_FUNCTION(Rem_Ext_Hdr)
        CONCEPT_FUNCTION(Add_CRSC)
        CONCEPT_FUNCTION(Get_Period_us)
        CONCEPT_FUNCTION(RTP_Context_Create)
        CONCEPT_FUNCTION(RTP_Context_destroy)
        CONCEPT_FUNCTION(Init_Context)
        CONCEPT_FUNCTION(RTP_Session_Save_Cxinfo)
        CONCEPT_FUNCTION(RTP_Session_Restore_Cxinfo)
        CONCEPT_FUNCTION(RTP_Sd_Pkt)
        CONCEPT_FUNCTION(RTP_Receive)
}


#endif // __LIBRARY_H
