#ifndef __LIBRARY_H
#define __LIBRARY_H

// user definition ...

extern "C" {
    CONCEPT_DLL_API ON_CREATE_CONTEXT MANAGEMENT_PARAMETERS;
    CONCEPT_DLL_API ON_DESTROY_CONTEXT MANAGEMENT_PARAMETERS;

    CONCEPT_FUNCTION(SSHConnect)
    CONCEPT_FUNCTION(SSHFingerprint)
    CONCEPT_FUNCTION(SSHAuth)
    CONCEPT_FUNCTION(SSHAuthPublicKey)
    CONCEPT_FUNCTION(SSHChannelOpen)
    CONCEPT_FUNCTION(SSHLastError)
    CONCEPT_FUNCTION(SSHLastErrorString)
    CONCEPT_FUNCTION(SSHShell)
    CONCEPT_FUNCTION(SSHProcess)
    CONCEPT_FUNCTION(SSHExec)
    CONCEPT_FUNCTION(SSHRead)
    CONCEPT_FUNCTION(SSHWrite)
    CONCEPT_FUNCTION(SSHSendEOF)
    CONCEPT_FUNCTION(SSHSetKeepAlive)
    CONCEPT_FUNCTION(SSHSendKeepAlive)
    CONCEPT_FUNCTION(SSHSetBlocking)
    CONCEPT_FUNCTION(SSHChannelClose)
    CONCEPT_FUNCTION(SSHDisconnect)
    CONCEPT_FUNCTION(SSHChannelEOF)
    CONCEPT_FUNCTION(SSHChannelPTY)
}

#endif // __LIBRARY_H
