#ifndef __LIBRARY_H
#define __LIBRARY_H

#include "stdlibrary.h"

// user definition ...
#define BUFFER_SIZE         0xFFFF  // 64k buffer

extern "C" {
	    CONCEPT_DLL_API ON_CREATE_CONTEXT MANAGEMENT_PARAMETERS;
        CONCEPT_DLL_API ON_DESTROY_CONTEXT MANAGEMENT_PARAMETERS;

        // debugger functions
        CONCEPT_DLL_API CONCEPT_CreateDebugPipe CONCEPT_API_PARAMETERS;
        CONCEPT_DLL_API CONCEPT_DestroyDebugPipe CONCEPT_API_PARAMETERS;

        CONCEPT_DLL_API CONCEPT_GetAPID CONCEPT_API_PARAMETERS;
        CONCEPT_DLL_API CONCEPT_GetParentAPID CONCEPT_API_PARAMETERS;

        CONCEPT_DLL_API CONCEPT_PeekAPMessage CONCEPT_API_PARAMETERS;
        CONCEPT_DLL_API CONCEPT_GetAPMessage CONCEPT_API_PARAMETERS;
        CONCEPT_DLL_API CONCEPT_SendAPMessage CONCEPT_API_PARAMETERS;

        // other functions declared here
        CONCEPT_DLL_API CONCEPT_send_message CONCEPT_API_PARAMETERS;
        CONCEPT_DLL_API CONCEPT_get_message CONCEPT_API_PARAMETERS;
        CONCEPT_DLL_API CONCEPT_wait_message_ID CONCEPT_API_PARAMETERS;
        CONCEPT_DLL_API CONCEPT_BeginUpdateSession CONCEPT_API_PARAMETERS;
        CONCEPT_DLL_API CONCEPT_EndUpdateSession CONCEPT_API_PARAMETERS;
        CONCEPT_DLL_API CONCEPT_EndUpdateSession2 CONCEPT_API_PARAMETERS;

        CONCEPT_DLL_API CONCEPT_CheckPoint CONCEPT_API_PARAMETERS;

        CONCEPT_DLL_API CONCEPT___DEBUG_PIPEW CONCEPT_API_PARAMETERS;
        CONCEPT_DLL_API CONCEPT___DEBUG_PIPER CONCEPT_API_PARAMETERS;

        CONCEPT_FUNCTION(GetRemoteIP)
        CONCEPT_FUNCTION(LocalTimer)
        CONCEPT_FUNCTION(HaveMessage)
        CONCEPT_FUNCTION(Hibernate)
        CONCEPT_FUNCTION(SetApplicationEventTimeout)
        CONCEPT_FUNCTION(CreateRTSocket)
        CONCEPT_FUNCTION(CloseRTSocket)
        CONCEPT_FUNCTION(ConceptProtocolSecured)
        CONCEPT_FUNCTION(WaitRTSocket)
        CONCEPT_FUNCTION(UpgradeTLS)
        //CONCEPT_DLL_API confirm_message CONCEPT_API_PARAMETERS;

        CONCEPT_DLL_API raw_send CONCEPT_API_PARAMETERS;
        CONCEPT_DLL_API raw_receive CONCEPT_API_PARAMETERS;

        CONCEPT_FUNCTION(MetaCode)
        CONCEPT_FUNCTION(protect)
        CONCEPT_FUNCTION(IsClient)

        CONCEPT_FUNCTION(RegisterLooper)
        CONCEPT_FUNCTION(UnregisterLooper)
}


#endif // __LIBRARY_H
