#ifndef __LIBRARY_H
#define __LIBRARY_H

#include "stdlibrary.h"

extern "C" {
    CONCEPT_DLL_API ON_CREATE_CONTEXT MANAGEMENT_PARAMETERS;
    CONCEPT_DLL_API ON_DESTROY_CONTEXT MANAGEMENT_PARAMETERS;

    CONCEPT_FUNCTION(DBFUpdateName)
    //CONCEPT_FUNCTION(DBFCreate)
    CONCEPT_FUNCTION(DBFOpen)
    CONCEPT_FUNCTION(DBFClose)
    CONCEPT_FUNCTION(DBFMove)
    CONCEPT_FUNCTION(DBFPutRecord)
    CONCEPT_FUNCTION(DBFInsertRecord)
    CONCEPT_FUNCTION(DBFAddRecord)
    CONCEPT_FUNCTION(DBFIsDeleted)
    CONCEPT_FUNCTION(DBFDelete)
    CONCEPT_FUNCTION(DBFFindField)
    CONCEPT_FUNCTION(DBFLastError)
    CONCEPT_FUNCTION(DBFLastErrorString)
    CONCEPT_FUNCTION(DBFType)
    CONCEPT_FUNCTION(DBFInfo)
    CONCEPT_FUNCTION(DBFFieldInfo)
    CONCEPT_FUNCTION(DBFValue)
    CONCEPT_FUNCTION(DBFGet)
    CONCEPT_FUNCTION(DBFGetName)
    CONCEPT_FUNCTION(DBFUpdate)
    CONCEPT_FUNCTION(DBFUpdateName)
    CONCEPT_FUNCTION(DBFNull)
    CONCEPT_FUNCTION(DBFNullName)
}


#endif // __LIBRARY_H
