#ifndef __LIBRARY_H
#define __LIBRARY_H

#include "stdlibrary.h"

extern "C" {
    CONCEPT_DLL_API ON_CREATE_CONTEXT MANAGEMENT_PARAMETERS;
    CONCEPT_DLL_API ON_DESTROY_CONTEXT MANAGEMENT_PARAMETERS;

    CONCEPT_FUNCTION(FBConnect)
    CONCEPT_FUNCTION(FBDisconnect)
    CONCEPT_FUNCTION(FBError)
    CONCEPT_FUNCTION(FBErrorCode)
    CONCEPT_FUNCTION(FBTransaction)
    CONCEPT_FUNCTION(FBCommit)
    CONCEPT_FUNCTION(FBRollback)
    CONCEPT_FUNCTION(FBNonQuery)
    CONCEPT_FUNCTION(FBQuery)
    CONCEPT_FUNCTION(FBFreeResult)

    CONCEPT_FUNCTION(FBFetchForward)

    CONCEPT_FUNCTION(FBGetValue)
    CONCEPT_FUNCTION(FBIsBlob)
    CONCEPT_FUNCTION(FBGetBlobId)
    CONCEPT_FUNCTION(FBIsNull)
    CONCEPT_FUNCTION(FBDescribeCol)
    CONCEPT_FUNCTION(FBColumnName)
    CONCEPT_FUNCTION(FBCountColumns)
    CONCEPT_FUNCTION(FBAffectedRows)

    CONCEPT_FUNCTION(FBBlobOpen)
    CONCEPT_FUNCTION(FBBlobRead)
    CONCEPT_FUNCTION(FBBlobWrite)
    CONCEPT_FUNCTION(FBBlobSeek)
    CONCEPT_FUNCTION(FBBlobClose)
    CONCEPT_FUNCTION(FBBlobCreate)

    //CONCEPT_FUNCTION(FBCountRows)
}


#endif // __LIBRARY_H
