#ifndef __LIBRARY_H
#define __LIBRARY_H

#include "stdlibrary.h"

extern "C" {
    CONCEPT_DLL_API ON_CREATE_CONTEXT MANAGEMENT_PARAMETERS;
    CONCEPT_DLL_API ON_DESTROY_CONTEXT MANAGEMENT_PARAMETERS;

    CONCEPT_FUNCTION(LoadObject)
    CONCEPT_FUNCTION(CloseObject)
    CONCEPT_FUNCTION(ObjectDetect)
    CONCEPT_FUNCTION(FaceRecognize)
    CONCEPT_FUNCTION(CloseRecognize)

    CONCEPT_FUNCTION(ReadCamera)
    CONCEPT_FUNCTION(OpenCamera)
    CONCEPT_FUNCTION(CloseCamera)
    CONCEPT_FUNCTION(CameraFrame)
}


#endif // __LIBRARY_H
