#ifndef __LIBRARY_H
#define __LIBRARY_H

#include "stdlibrary.h"

extern "C" {
    CONCEPT_DLL_API ON_CREATE_CONTEXT MANAGEMENT_PARAMETERS;
    CONCEPT_DLL_API ON_DESTROY_CONTEXT MANAGEMENT_PARAMETERS;

    CONCEPT_FUNCTION(SIPPhoneCreate)
    CONCEPT_FUNCTION(SIPPhoneDestroy)
    CONCEPT_FUNCTION(SIPPhoneDestroy)
    CONCEPT_FUNCTION(SIPPhoneSetPortBase)
    CONCEPT_FUNCTION(SIPPhoneSetSilenceDetector)
    CONCEPT_FUNCTION(SIPPhoneSetJitter)
    CONCEPT_FUNCTION(SIPPhoneConnect)
    CONCEPT_FUNCTION(SIPPhoneCall)
    CONCEPT_FUNCTION(SIPPhoneHoldRetrieveCall)
    CONCEPT_FUNCTION(SIPPhoneHangupCurrentCall)
    CONCEPT_FUNCTION(SIPPhoneTransfer)
    CONCEPT_FUNCTION(SIPPhoneForward)
    CONCEPT_FUNCTION(SIPPhoneHangupAll)
    CONCEPT_FUNCTION(SIPPhoneAnswer)
    CONCEPT_FUNCTION(SIPPhoneReject)
    CONCEPT_FUNCTION(SIPPhoneSendTone)
    CONCEPT_FUNCTION(SIPPhoneAddListener)
    CONCEPT_FUNCTION(SIPPhoneRemoveListener)
    CONCEPT_FUNCTION(SIPPhoneUnregister)
    CONCEPT_FUNCTION(SIPPhoneGetCodecs)
    CONCEPT_FUNCTION(SIPPhoneSetCodecsOrder)
    CONCEPT_FUNCTION(SIPPhoneIsRegistered)
    CONCEPT_FUNCTION(SIPPhoneSetSTUNServer)

    CONCEPT_FUNCTION(SIPPhoneOnEstablishedCall)
    CONCEPT_FUNCTION(SIPPhoneOnClearedCall)
    CONCEPT_FUNCTION(SIPPhoneOnUserInputString)

    CONCEPT_FUNCTION(SIPPhoneOnShowIncoming)
    CONCEPT_FUNCTION(SIPPhoneOnShowOutgoing)
    CONCEPT_FUNCTION(SIPPhoneOnMediaFrame)

    CONCEPT_FUNCTION(SIPPhoneOnAlerting)

    CONCEPT_FUNCTION(SIPPhoneOnOpenMediaStreamDelegate)
    CONCEPT_FUNCTION(SIPPhoneOnMediaFrameRequest)

    CONCEPT_FUNCTION(SIPPhoneOnConnectRequest)

    CONCEPT_FUNCTION(SIPMediaStreamRead)
    CONCEPT_FUNCTION(SIPMediaStreamWrite)
    CONCEPT_FUNCTION(SIPMediaStreamWriteAll)
    CONCEPT_FUNCTION(SIPMediaStreamClose)
    CONCEPT_FUNCTION(SIPMediaStreamNotUsed)
    CONCEPT_FUNCTION(SIPMediaStreamIsSink)
    CONCEPT_FUNCTION(SIPMediaStreamIsOpen)
    CONCEPT_FUNCTION(SIPMediaStreamIsSource)
    CONCEPT_FUNCTION(SIPMediaStreamIsPaused)
    CONCEPT_FUNCTION(SIPMediaStreamIsSynchronous)
    CONCEPT_FUNCTION(SIPMediaStreamFormat)
    CONCEPT_FUNCTION(SIPMediaStreamSetDataSize)
    CONCEPT_FUNCTION(SIPMediaStreamGetDataSize)
    CONCEPT_FUNCTION(SIPMediaStreamStart)
    CONCEPT_FUNCTION(SIPMediaStreamPause)
    
    CONCEPT_FUNCTION(SIPPhoneSetNoMediaTimeout)
    CONCEPT_FUNCTION(SIPPhoneGetNoMediaTimeout)
}
#endif // __LIBRARY_H

